#!/usr/bin/env node
"use strict";

var _fs = _interopRequireDefault(require("fs"));

var _fragmentTypes = require("./server/fragmentTypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

switch (process.argv[1]) {
  case "fragment":
    (0, _fragmentTypes.execFile)(require(process.argv[2])) // eslint-disable-line
    .then(function (data) {
      return _fs.default.writeFileSync(process.argv[3], data);
    }).then(function () {
      return process.exit();
    });
    break;

  default:
}