"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.bs58 = void 0;

var _baseX = _interopRequireDefault(require("base-x"));

var _window = _interopRequireDefault(require("global/window"));

var _isBrowser = _interopRequireDefault(require("./isBrowser"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint no-underscore-dangle: ["error", { "allow": ["__ENV__"] }] */
var bs58 = (0, _baseX.default)("123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz");
exports.bs58 = bs58;

if (_isBrowser.default && typeof _window.default.__ENV__ === "string") {
  var data = bs58.decode(_window.default.__ENV__).toString();
  _window.default.__ENV__ = JSON.parse(data);
}

var _default = (_isBrowser.default ? _window.default.__ENV__ : process.env) || {};

exports.default = _default;