"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _window = _interopRequireDefault(require("global/window"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function memoryStorage() {
  var map = new Map();
  map.setItem = map.set;
  map.getItem = map.get;
  map.removeItem = map.delete;
  return map;
}

var _default = _window.default.localStorage || memoryStorage();

exports.default = _default;