"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.format = format;
exports.default = void 0;

var _setDisplayName2 = _interopRequireDefault(require("recompose/setDisplayName"));

var _withPropsOnChange2 = _interopRequireDefault(require("recompose/withPropsOnChange"));

var _compose2 = _interopRequireDefault(require("lodash/fp/compose"));

var _camelCase2 = _interopRequireDefault(require("lodash/camelCase"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _withQuery = _interopRequireDefault(require("./withQuery"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function format(name, props) {
  var result = props[name];
  return _defineProperty({
    totalCount: (0, _get2.default)(result, ["totalCount"], 0)
  }, name, (0, _get2.default)(result, ["nodes"], []));
}

var _default = function _default(name, query) {
  return function (Component) {
    return (0, _compose2.default)((0, _setDisplayName2.default)((0, _camelCase2.default)(["withOffsetPagination", name])), (0, _withQuery.default)(name, query), (0, _withPropsOnChange2.default)([name], function (props) {
      return format(name, props);
    }))(Component);
  };
};

exports.default = _default;