"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _assertResult2 = _interopRequireDefault(require("thelper/assertResult"));

var _assertEnv2 = _interopRequireDefault(require("thelper/assertEnv"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _isPlainObject2 = _interopRequireDefault(require("lodash/isPlainObject"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _forEach2 = _interopRequireDefault(require("lodash/forEach"));

var _identity2 = _interopRequireDefault(require("lodash/identity"));

var _defaults3 = _interopRequireDefault(require("lodash/defaults"));

var _assign2 = _interopRequireDefault(require("lodash/assign"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _size2 = _interopRequireDefault(require("lodash/size"));

var _crypto = _interopRequireDefault(require("crypto"));

var _cookie = _interopRequireDefault(require("cookie"));

var _bodyParser = require("body-parser");

var _jw = _interopRequireDefault(require("jw58"));

var _apolloServerErrors = require("apollo-server-errors");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var EXPIRED_IN = 14 * 24 * 60 * 60; // 7 days in seconds

function assertKeys(keys) {
  (0, _assertResult2.default)(keys, new TypeError("keys least one is required"));
  if ((0, _size2.default)(keys) > 1) return [keys];
  return (0, _map2.default)(keys, function (rsa, name) {
    return [rsa, name];
  })[0];
}

var JsonWebToken =
/*#__PURE__*/
function () {
  function JsonWebToken(keys, options) {
    _classCallCheck(this, JsonWebToken);

    _defineProperty(this, "cryptor", null);

    this.cryptor = _construct(_jw.default, _toConsumableArray(assertKeys(keys)));
    (0, _assign2.default)(this, (0, _defaults3.default)(options, {
      viewerName: "viewer",
      expiresIn: EXPIRED_IN,
      toUser: _identity2.default,
      toViewer: _identity2.default,
      onSignIn: _identity2.default,
      onSignOut: _identity2.default,
      onRenew: _identity2.default
    }));
    return this;
  }

  _createClass(JsonWebToken, [{
    key: "sign",
    value: function sign() {
      var _this$cryptor;

      return (_this$cryptor = this.cryptor).sign.apply(_this$cryptor, arguments);
    }
  }, {
    key: "verify",
    value: function verify() {
      var _this$cryptor2;

      return (_this$cryptor2 = this.cryptor).verify.apply(_this$cryptor2, arguments);
    }
  }, {
    key: "signRefresh",
    value: function signRefresh(correlationId, passport) {
      for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        args[_key - 2] = arguments[_key];
      }

      return this.sign.apply(this, [{
        sub: "auth_refresh",
        exp: Math.floor(Date.now() / 1000) + this.expiresIn,
        correlationId: correlationId,
        passport: passport
      }].concat(args));
    }
  }, {
    key: "signAccess",
    value: function signAccess(passport) {
      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      return this.sign.apply(this, [{
        sub: "auth_access",
        exp: Math.floor(Date.now() / 1000) + 60 * 60,
        passport: passport
      }].concat(args));
    }
  }, {
    key: "verifyRefresh",
    value: function verifyRefresh(token, options) {
      var _this$verify = this.verify(token, _objectSpread({
        sub: "auth_refresh"
      }, options)),
          correlationId = _this$verify.correlationId,
          passport = _this$verify.passport,
          iss = _this$verify.iss;

      return _objectSpread({}, passport, {
        correlationId: correlationId,
        issuer: iss
      });
    }
  }, {
    key: "verifyAccess",
    value: function verifyAccess(token, options) {
      if (!token) return {};

      var _this$verify2 = this.verify(token, _objectSpread({
        sub: "auth_access"
      }, options)),
          passport = _this$verify2.passport,
          iss = _this$verify2.iss;

      return {
        user: this.toUser(passport),
        viewer: this.toViewer(passport),
        issuer: iss
      };
    }
  }, {
    key: "signIn",
    value: function () {
      var _signIn = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(params) {
        var result, issuer, correlationId, isUnfamiliar, passport, id, refreshToken, accessToken;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.onSignIn(params);

              case 2:
                result = _context.sent;
                issuer = result.issuer, correlationId = result.correlationId, isUnfamiliar = result.isUnfamiliar, passport = _objectWithoutProperties(result, ["issuer", "correlationId", "isUnfamiliar"]);
                id = result.correlationId || params.correlationId || _crypto.default.randomBytes(16).toString("hex");
                (0, _forEach2.default)(passport, function (data) {
                  (0, _assertResult2.default)((0, _includes2.default)(["boolean", "string", "number"], _typeof(data)) || (0, _isPlainObject2.default)(data), new TypeError("results must is boolean, string, number or plain object on sign-in"));
                });

                if (isUnfamiliar) {
                  _context.next = 10;
                  break;
                }

                refreshToken = this.signRefresh(id, passport, issuer);
                accessToken = this.signAccess(passport, issuer);
                return _context.abrupt("return", _objectSpread({}, passport, {
                  correlationId: id,
                  refreshToken: refreshToken,
                  accessToken: accessToken
                }));

              case 10:
                return _context.abrupt("return", _objectSpread({}, passport, {
                  correlationId: id,
                  isUnfamiliar: isUnfamiliar
                }));

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function signIn(_x) {
        return _signIn.apply(this, arguments);
      }

      return signIn;
    }()
  }, {
    key: "signOut",
    value: function () {
      var _signOut = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(params) {
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (0, _assertResult2.default)(params.correlationId, new Error("correlationId is required"));
                return _context2.abrupt("return", this.onSignOut(params));

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function signOut(_x2) {
        return _signOut.apply(this, arguments);
      }

      return signOut;
    }()
  }, {
    key: "renew",
    value: function () {
      var _renew = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(params) {
        var signature, _ref, correlationId, passport, id, refreshToken, accessToken;

        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                (0, _assertResult2.default)(params.refreshToken, new Error("refreshToken is required"));
                (0, _assertResult2.default)(params.correlationId, new Error("correlationId is required"));
                signature = this.verifyRefresh(params.refreshToken);

                if (!(params.correlationId !== signature.correlationId)) {
                  _context3.next = 5;
                  break;
                }

                throw new Error("not match to correlation id");

              case 5:
                _context3.next = 7;
                return this.onRenew(_objectSpread({}, (0, _omit2.default)(params, ["refreshToken"]), signature));

              case 7:
                _ref = _context3.sent;
                correlationId = _ref.correlationId;
                passport = _objectWithoutProperties(_ref, ["correlationId"]);
                (0, _forEach2.default)(passport, function (data) {
                  (0, _assertResult2.default)((0, _includes2.default)(["boolean", "string", "number"], _typeof(data)) || (0, _isPlainObject2.default)(data), new TypeError("results must is boolean, string, number or plain object on renew"));
                });
                id = correlationId || signature.correlationId;
                refreshToken = this.signRefresh(id, passport, signature.issuer);
                accessToken = this.signAccess(passport, signature.issuer);
                return _context3.abrupt("return", _objectSpread({}, passport, {
                  correlationId: id,
                  refreshToken: refreshToken,
                  accessToken: accessToken
                }));

              case 15:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function renew(_x3) {
        return _renew.apply(this, arguments);
      }

      return renew;
    }()
  }, {
    key: "applyMiddleware",
    value: function applyMiddleware(app, options) {
      var _this = this;

      var _defaults2 = (0, _defaults3.default)({}, options, {
        path: "/auth"
      }),
          path = _defaults2.path;

      app.post(path, (0, _bodyParser.json)());
      app.post(path,
      /*#__PURE__*/
      function () {
        var _ref2 = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee4(req, res) {
          var method, correlationId, result;
          return _regenerator.default.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  method = req.body.method;

                  if ((0, _includes2.default)(["signIn", "signOut", "renew"], method)) {
                    _context4.next = 4;
                    break;
                  }

                  res.sendStatus(404);
                  return _context4.abrupt("return");

                case 4:
                  try {
                    correlationId = _cookie.default.parse(req.headers.cookie)["x-correlation-id"];
                  } catch (e) {// empty
                  }

                  _context4.prev = 5;
                  _context4.next = 8;
                  return _this[method](_objectSpread({}, req.body, {
                    correlationId: correlationId
                  }));

                case 8:
                  result = _context4.sent;

                  if (result.correlationId) {
                    res.append("Set-Cookie", _cookie.default.serialize("x-correlation-id", result.correlationId, {
                      httpOnly: true,
                      maxAge: 365 * 24 * 60 * 60
                    }));
                  }

                  res.json(_objectSpread({
                    status: "ok"
                  }, (0, _omit2.default)(result, ["correlationId"]))).end();
                  _context4.next = 16;
                  break;

                case 13:
                  _context4.prev = 13;
                  _context4.t0 = _context4["catch"](5);
                  res.status(403).send({
                    error: _context4.t0.message
                  });

                case 16:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, null, [[5, 13]]);
        }));

        return function (_x4, _x5) {
          return _ref2.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "contextParser",
    value: function contextParser() {
      var _this2 = this;

      var viewerName = this.viewerName;
      return (
        /*#__PURE__*/
        function () {
          var _ref3 = _asyncToGenerator(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee5(context) {
            var req, res, connection, token, _ref4, authorization, _$exec, _$exec2, _objectSpread2, _ref5, user, viewer, issuer;

            return _regenerator.default.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    req = context.req, res = context.res, connection = context.connection;

                    try {
                      _ref4 = connection ? connection.context : req.headers, authorization = _ref4.authorization;
                      _$exec = /^Bearer (.+)$/.exec(authorization);
                      _$exec2 = _slicedToArray(_$exec, 2);
                      token = _$exec2[1];
                    } catch (e) {// empty
                    }

                    _context5.prev = 2;
                    _context5.next = 5;
                    return _this2.verifyAccess(token);

                  case 5:
                    _ref5 = _context5.sent;
                    user = _ref5.user;
                    viewer = _ref5.viewer;
                    issuer = _ref5.issuer;
                    return _context5.abrupt("return", _objectSpread({}, context, (_objectSpread2 = {
                      user: user
                    }, _defineProperty(_objectSpread2, viewerName, viewer), _defineProperty(_objectSpread2, "issuer", issuer), _objectSpread2)));

                  case 12:
                    _context5.prev = 12;
                    _context5.t0 = _context5["catch"](2);
                    (0, _assertEnv2.default)(function () {
                      if (!res) throw new _apolloServerErrors.AuthenticationError(_context5.t0.message);
                      res.append("X-Content-Extend", _context5.t0.message);
                    });
                    throw new _apolloServerErrors.AuthenticationError("token invalid");

                  case 16:
                  case "end":
                    return _context5.stop();
                }
              }
            }, _callee5, null, [[2, 12]]);
          }));

          return function (_x6) {
            return _ref3.apply(this, arguments);
          };
        }()
      );
    }
  }]);

  return JsonWebToken;
}();

exports.default = JsonWebToken;