import _ from "lodash";

const { default: localStorage } = jest.requireActual("../localStorage");

export default {
  setItem: jest.fn(localStorage.setItem.bind(localStorage)),
  getItem: jest.fn(localStorage.getItem.bind(localStorage)),
  clear: jest.fn(localStorage.clear.bind(localStorage)),
  apply: data => {
    _.forEach(data, (value, key) => localStorage.setItem(key, value));
  },
};
