/* eslint no-underscore-dangle: ["error", { "allow": ["__ENV__"] }] */

import baseX from "base-x";
import window from "global/window";
import isBrowser from "./isBrowser";

export const bs58 = baseX(
  "123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",
);

if (isBrowser && typeof window.__ENV__ === "string") {
  const data = bs58.decode(window.__ENV__).toString();
  window.__ENV__ = JSON.parse(data);
}

export default (isBrowser ? window.__ENV__ : process.env) || {};
