import React from "react";
import { ApolloConsumer } from "react-apollo";

export default () => Component => props => (
  <ApolloConsumer>
    {client => <Component {...props} client={client} />}
  </ApolloConsumer>
);
